diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 6c921e9..2abad21 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,5 +1,16 @@
 2019-10-19  Tom Tromey  <tom@tromey.com>
 
+	* unittests/main-thread-selftests.c: New file.
+	* Makefile.in (SUBDIR_UNITTESTS_SRCS): Add
+	main-thread-selftests.c.
+	* ser-event.h (run_on_main_thread): Declare.
+	* ser-event.c (runnable_event, runnables, runnable_mutex): New
+	globals.
+	(run_events, run_on_main_thread, _initialize_ser_event): New
+	functions.
+
+2019-10-19  Tom Tromey  <tom@tromey.com>
+
 	* main.c (setup_alternate_signal_stack): Remove.
 	(captured_main_1): Use gdb::alternate_signal_stack.
 	* gdbsupport/alt-stack.h: New file.
diff --git a/gdb/Makefile.in b/gdb/Makefile.in
index 4ace519..5e01c32 100644
--- a/gdb/Makefile.in
+++ b/gdb/Makefile.in
@@ -429,6 +429,7 @@
 	unittests/optional-selftests.c \
 	unittests/parse-connection-spec-selftests.c \
 	unittests/ptid-selftests.c \
+	unittests/main-thread-selftests.c \
 	unittests/mkdir-recursive-selftests.c \
 	unittests/rsp-low-selftests.c \
 	unittests/scoped_fd-selftests.c \
diff --git a/gdb/ser-event.c b/gdb/ser-event.c
index a65a186..029ced7 100644
--- a/gdb/ser-event.c
+++ b/gdb/ser-event.c
@@ -20,6 +20,10 @@
 #include "ser-event.h"
 #include "serial.h"
 #include "gdbsupport/filestuff.h"
+#if CXX_STD_THREAD
+#include <mutex>
+#endif
+#include "event-loop.h"
 
 /* On POSIX hosts, a serial_event is basically an abstraction for the
    classical self-pipe trick.
@@ -217,3 +221,77 @@
   ResetEvent (state->event);
 #endif
 }
+
+
+
+/* The serial event used when posting runnables.  */
+
+static struct serial_event *runnable_event;
+
+/* Runnables that have been posted.  */
+
+static std::vector<std::function<void ()>> runnables;
+
+#if CXX_STD_THREAD
+
+/* Mutex to hold when handling runnable_event or runnables.  */
+
+static std::mutex runnable_mutex;
+
+#endif
+
+/* Run all the queued runnables.  */
+
+static void
+run_events (int error, gdb_client_data client_data)
+{
+  std::vector<std::function<void ()>> local;
+
+  /* Hold the lock while changing the globals, but not while running
+     the runnables.  */
+  {
+#if CXX_STD_THREAD
+    std::lock_guard<std::mutex> lock (runnable_mutex);
+#endif
+
+    /* Clear the event fd.  Do this before flushing the events list,
+       so that any new event post afterwards is sure to re-awaken the
+       event loop.  */
+    serial_event_clear (runnable_event);
+
+    /* Move the vector in case running a runnable pushes a new
+       runnable.  */
+    local = std::move (runnables);
+  }
+
+  for (auto &item : local)
+    {
+      try
+	{
+	  item ();
+	}
+      catch (...)
+	{
+	  /* Ignore exceptions in the callback.  */
+	}
+    }
+}
+
+/* See ser-event.h.  */
+
+void
+run_on_main_thread (std::function<void ()> &&func)
+{
+#if CXX_STD_THREAD
+  std::lock_guard<std::mutex> lock (runnable_mutex);
+#endif
+  runnables.emplace_back (std::move (func));
+  serial_event_set (runnable_event);
+}
+
+void
+_initialize_ser_event ()
+{
+  runnable_event = make_serial_event ();
+  add_file_handler (serial_event_fd (runnable_event), run_events, nullptr);
+}
diff --git a/gdb/ser-event.h b/gdb/ser-event.h
index 1373485..61a84f9 100644
--- a/gdb/ser-event.h
+++ b/gdb/ser-event.h
@@ -19,6 +19,8 @@
 #ifndef SER_EVENT_H
 #define SER_EVENT_H
 
+#include <functional>
+
 /* This is used to be able to signal the event loop (or any other
    select/poll) of events, in a race-free manner.
 
@@ -48,4 +50,8 @@
    call is made.  */
 extern void serial_event_clear (struct serial_event *event);
 
+/* Send a runnable to the main thread.  */
+
+extern void run_on_main_thread (std::function<void ()> &&);
+
 #endif
diff --git a/gdb/unittests/main-thread-selftests.c b/gdb/unittests/main-thread-selftests.c
new file mode 100644
index 0000000..e5bd2d3
--- /dev/null
+++ b/gdb/unittests/main-thread-selftests.c
@@ -0,0 +1,80 @@
+/* Self tests for run_on_main_thread
+
+   Copyright (C) 2019 Free Software Foundation, Inc.
+
+   This file is part of GDB.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3 of the License, or
+   (at your option) any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
+
+#include "defs.h"
+#include "gdbsupport/selftest.h"
+#include "gdbsupport/block-signals.h"
+#include "ser-event.h"
+#include "event-loop.h"
+#if CXX_STD_THREAD
+#include <thread>
+#endif
+
+namespace selftests {
+namespace main_thread_tests {
+
+#if CXX_STD_THREAD
+
+static bool done;
+
+static void
+set_done ()
+{
+  run_on_main_thread ([] ()
+    {
+      done = true;
+    });
+}
+
+static void
+run_tests ()
+{
+  std::thread thread;
+
+  done = false;
+
+  {
+    gdb::block_signals blocker;
+
+    thread = std::thread (set_done);
+  }
+
+  while (!done && gdb_do_one_event () >= 0)
+    ;
+
+  /* Actually the test will just hang, but we want to test
+     something.  */
+  SELF_CHECK (done);
+
+  thread.join ();
+}
+
+#endif
+
+}
+}
+
+void
+_initialize_main_thread_selftests ()
+{
+#if CXX_STD_THREAD
+  selftests::register_test ("main_thread",
+			    selftests::main_thread_tests::run_tests);
+#endif
+}