diff --git a/gdb/ChangeLog b/gdb/ChangeLog
index 8e03dbf883..8d4aeacbfe 100644
--- a/gdb/ChangeLog
+++ b/gdb/ChangeLog
@@ -1,3 +1,16 @@
+2019-01-24  John Baldwin  <jhb@FreeBSD.org>
+
+	* aarch64-fbsd-tdep.c (aarch64_fbsd_gregmap)
+	(aarch64_fbsd_fpregmap): Move earlier.
+	(AARCH64_MCONTEXT_REG_SIZE, AARCH64_MCONTEXT_FPREG_SIZE): Delete.
+	(aarch64_fbsd_sigframe_init): Use trad_frame_set_reg_regmap
+	instead of individual calls to trad_frame_set_reg_addr.
+	* arm-fbsd-tdep.c (arm_fbsd_gregmap, arm_fbsd_vfpregmap): Move
+	earlier.
+	(ARM_MCONTEXT_REG_SIZE, ARM_MCONTEXT_VFP_REG_SIZE): Delete.
+	(arm_fbsd_sigframe_init): Use trad_frame_set_reg_regmap
+	instead of individual calls to trad_frame_set_reg_addr.
+
 2019-01-22  Philippe Waroquiers  <philippe.waroquiers@skynet.be>
 
 	* event-top.c (handle_line_of_input): use unique_xmalloc_ptr for
diff --git a/gdb/aarch64-fbsd-tdep.c b/gdb/aarch64-fbsd-tdep.c
index 7dbdba691e..c611ff350b 100644
--- a/gdb/aarch64-fbsd-tdep.c
+++ b/gdb/aarch64-fbsd-tdep.c
@@ -29,6 +29,26 @@
 #include "tramp-frame.h"
 #include "trad-frame.h"
 
+/* Register maps.  */
+
+static const struct regcache_map_entry aarch64_fbsd_gregmap[] =
+  {
+    { 30, AARCH64_X0_REGNUM, 8 }, /* x0 ... x29 */
+    { 1, AARCH64_LR_REGNUM, 8 },
+    { 1, AARCH64_SP_REGNUM, 8 },
+    { 1, AARCH64_PC_REGNUM, 8 },
+    { 1, AARCH64_CPSR_REGNUM, 4 },
+    { 0 }
+  };
+
+static const struct regcache_map_entry aarch64_fbsd_fpregmap[] =
+  {
+    { 32, AARCH64_V0_REGNUM, 16 }, /* v0 ... v31 */
+    { 1, AARCH64_FPSR_REGNUM, 4 },
+    { 1, AARCH64_FPCR_REGNUM, 4 },
+    { 0 }
+  };
+
 /* In a signal frame, sp points to a 'struct sigframe' which is
    defined as:
 
@@ -49,8 +69,6 @@
    by the floating point register set.  The floating point register
    set is only valid if the _MC_FP_VALID flag is set in mc_flags.  */
 
-#define AARCH64_MCONTEXT_REG_SIZE               8
-#define AARCH64_MCONTEXT_FPREG_SIZE             16
 #define AARCH64_SIGFRAME_UCONTEXT_OFFSET	80
 #define AARCH64_UCONTEXT_MCONTEXT_OFFSET	16
 #define	AARCH64_MCONTEXT_FPREGS_OFFSET		272
@@ -68,47 +86,22 @@ aarch64_fbsd_sigframe_init (const struct tramp_frame *self,
   struct gdbarch *gdbarch = get_frame_arch (this_frame);
   enum bfd_endian byte_order = gdbarch_byte_order (gdbarch);
   CORE_ADDR sp = get_frame_register_unsigned (this_frame, AARCH64_SP_REGNUM);
-  CORE_ADDR mcontext_addr =
-    sp
-    + AARCH64_SIGFRAME_UCONTEXT_OFFSET
-    + AARCH64_UCONTEXT_MCONTEXT_OFFSET;
+  CORE_ADDR mcontext_addr
+    = (sp
+       + AARCH64_SIGFRAME_UCONTEXT_OFFSET
+       + AARCH64_UCONTEXT_MCONTEXT_OFFSET);
   gdb_byte buf[4];
-  int i;
 
-  for (i = 0; i < 30; i++)
-    {
-      trad_frame_set_reg_addr (this_cache,
-			       AARCH64_X0_REGNUM + i,
-			       mcontext_addr + i * AARCH64_MCONTEXT_REG_SIZE);
-    }
-  trad_frame_set_reg_addr (this_cache, AARCH64_LR_REGNUM,
-			   mcontext_addr + 30 * AARCH64_MCONTEXT_REG_SIZE);
-  trad_frame_set_reg_addr (this_cache, AARCH64_SP_REGNUM,
-			   mcontext_addr + 31 * AARCH64_MCONTEXT_REG_SIZE);
-  trad_frame_set_reg_addr (this_cache, AARCH64_PC_REGNUM,
-			   mcontext_addr + 32 * AARCH64_MCONTEXT_REG_SIZE);
-  trad_frame_set_reg_addr (this_cache, AARCH64_CPSR_REGNUM,
-			   mcontext_addr + 33 * AARCH64_MCONTEXT_REG_SIZE);
+  trad_frame_set_reg_regmap (this_cache, aarch64_fbsd_gregmap, mcontext_addr,
+			     regcache_map_entry_size (aarch64_fbsd_gregmap));
 
   if (target_read_memory (mcontext_addr + AARCH64_MCONTEXT_FLAGS_OFFSET, buf,
 			  4) == 0
       && (extract_unsigned_integer (buf, 4, byte_order)
 	  & AARCH64_MCONTEXT_FLAG_FP_VALID))
-    {
-      for (i = 0; i < 32; i++)
-	{
-	  trad_frame_set_reg_addr (this_cache, AARCH64_V0_REGNUM + i,
-				   mcontext_addr
-				   + AARCH64_MCONTEXT_FPREGS_OFFSET
-				   + i * AARCH64_MCONTEXT_FPREG_SIZE);
-	}
-      trad_frame_set_reg_addr (this_cache, AARCH64_FPSR_REGNUM,
-			       mcontext_addr + AARCH64_MCONTEXT_FPREGS_OFFSET
-			       + 32 * AARCH64_MCONTEXT_FPREG_SIZE);
-      trad_frame_set_reg_addr (this_cache, AARCH64_FPCR_REGNUM,
-			       mcontext_addr + AARCH64_MCONTEXT_FPREGS_OFFSET
-			       + 32 * AARCH64_MCONTEXT_FPREG_SIZE + 4);
-    }
+    trad_frame_set_reg_regmap (this_cache, aarch64_fbsd_fpregmap,
+			       mcontext_addr + AARCH64_MCONTEXT_FPREGS_OFFSET,
+			       regcache_map_entry_size (aarch64_fbsd_fpregmap));
 
   trad_frame_set_id (this_cache, frame_id_build (sp, func));
 }
@@ -127,26 +120,6 @@ static const struct tramp_frame aarch64_fbsd_sigframe =
   aarch64_fbsd_sigframe_init
 };
 
-/* Register maps.  */
-
-static const struct regcache_map_entry aarch64_fbsd_gregmap[] =
-  {
-    { 30, AARCH64_X0_REGNUM, 8 }, /* x0 ... x29 */
-    { 1, AARCH64_LR_REGNUM, 8 },
-    { 1, AARCH64_SP_REGNUM, 8 },
-    { 1, AARCH64_PC_REGNUM, 8 },
-    { 1, AARCH64_CPSR_REGNUM, 4 },
-    { 0 }
-  };
-
-static const struct regcache_map_entry aarch64_fbsd_fpregmap[] =
-  {
-    { 32, AARCH64_V0_REGNUM, 16 }, /* v0 ... v31 */
-    { 1, AARCH64_FPSR_REGNUM, 4 },
-    { 1, AARCH64_FPCR_REGNUM, 4 },
-    { 0 }
-  };
-
 /* Register set definitions.  */
 
 const struct regset aarch64_fbsd_gregset =
diff --git a/gdb/arm-fbsd-tdep.c b/gdb/arm-fbsd-tdep.c
index 74d7e1d2b4..dea3abbdd3 100644
--- a/gdb/arm-fbsd-tdep.c
+++ b/gdb/arm-fbsd-tdep.c
@@ -30,6 +30,25 @@
 #include "trad-frame.h"
 #include "tramp-frame.h"
 
+/* Register maps.  */
+
+static const struct regcache_map_entry arm_fbsd_gregmap[] =
+  {
+    { 13, ARM_A1_REGNUM, 4 }, /* r0 ... r12 */
+    { 1, ARM_SP_REGNUM, 4 },
+    { 1, ARM_LR_REGNUM, 4 },
+    { 1, ARM_PC_REGNUM, 4 },
+    { 1, ARM_PS_REGNUM, 4 },
+    { 0 }
+  };
+
+static const struct regcache_map_entry arm_fbsd_vfpregmap[] =
+  {
+    { 32, ARM_D0_REGNUM, 8 }, /* d0 ... d31 */
+    { 1, ARM_FPSCR_REGNUM, 4 },
+    { 0 }
+  };
+
 /* In a signal frame, sp points to a 'struct sigframe' which is
    defined as:
 
@@ -67,8 +86,6 @@
    the sigframe, otherwise it is NULL.  There is no non-VFP floating
    point register state saved in the signal frame.  */
 
-#define ARM_MCONTEXT_REG_SIZE		4
-#define ARM_MCONTEXT_VFP_REG_SIZE	8
 #define ARM_SIGFRAME_UCONTEXT_OFFSET	64
 #define ARM_UCONTEXT_MCONTEXT_OFFSET	16
 #define ARM_MCONTEXT_VFP_PTR_OFFSET	72
@@ -89,31 +106,16 @@ arm_fbsd_sigframe_init (const struct tramp_frame *self,
 			     + ARM_UCONTEXT_MCONTEXT_OFFSET);
   ULONGEST mcontext_vfp_addr;
 
-  for (int i = 0; i < 16; i++)
-    {
-      trad_frame_set_reg_addr (this_cache,
-			       ARM_A1_REGNUM + i,
-			       mcontext_addr + i * ARM_MCONTEXT_REG_SIZE);
-    }
-  trad_frame_set_reg_addr (this_cache, ARM_PS_REGNUM,
-			   mcontext_addr + 16 * ARM_MCONTEXT_REG_SIZE);
+  trad_frame_set_reg_regmap (this_cache, arm_fbsd_gregmap, mcontext_addr,
+			     regcache_map_entry_size (arm_fbsd_gregmap));
 
   if (safe_read_memory_unsigned_integer (mcontext_addr
 					 + ARM_MCONTEXT_VFP_PTR_OFFSET, 4,
 					 byte_order,
 					 &mcontext_vfp_addr)
       && mcontext_vfp_addr != 0)
-    {
-      for (int i = 0; i < 32; i++)
-	{
-	  trad_frame_set_reg_addr (this_cache, ARM_D0_REGNUM + i,
-				   mcontext_vfp_addr
-				   + i * ARM_MCONTEXT_VFP_REG_SIZE);
-	}
-      trad_frame_set_reg_addr (this_cache, ARM_FPSCR_REGNUM,
-			       mcontext_vfp_addr
-			       + 32 * ARM_MCONTEXT_VFP_REG_SIZE);
-    }
+    trad_frame_set_reg_regmap (this_cache, arm_fbsd_vfpregmap, mcontext_vfp_addr,
+			       regcache_map_entry_size (arm_fbsd_vfpregmap));
 
   trad_frame_set_id (this_cache, frame_id_build (sp, func));
 }
@@ -132,25 +134,6 @@ static const struct tramp_frame arm_fbsd_sigframe =
   arm_fbsd_sigframe_init
 };
 
-/* Register maps.  */
-
-static const struct regcache_map_entry arm_fbsd_gregmap[] =
-  {
-    { 13, ARM_A1_REGNUM, 4 }, /* r0 ... r12 */
-    { 1, ARM_SP_REGNUM, 4 },
-    { 1, ARM_LR_REGNUM, 4 },
-    { 1, ARM_PC_REGNUM, 4 },
-    { 1, ARM_PS_REGNUM, 4 },
-    { 0 }
-  };
-
-static const struct regcache_map_entry arm_fbsd_vfpregmap[] =
-  {
-    { 32, ARM_D0_REGNUM, 8 }, /* d0 ... d31 */
-    { 1, ARM_FPSCR_REGNUM, 4 },
-    { 0 }
-  };
-
 /* Register set definitions.  */
 
 const struct regset arm_fbsd_gregset =